#if NOCH_NICHT_IN_VS2010_BETA2 
// #include <msclr\marshal_cppstd.h>
#endif

// ####################################################
// Beispiele aus
// Eine Vorlage fr Windows Forms-Anwendungen mit Standard-C++ 
 
using namespace System; // fr String
using namespace System::Windows::Forms; // fr die Steuerelemente 

int f(int x)
{
	return x+17;
}

void MeineLoesung_2(TextBox^ tb, int x)
{
tb->AppendText("Hallo Welt: \r\n");
tb->AppendText(String::Format("x={0} f(x)={1} \r\n",x,f(x)) );
}

// ####################################################
// Beispiele aus
// Typische C- und C++-Anweisungen

const int Max=17; // eine globale Variable eines vordefinierten Typs

class Punkt { // eine Klasse
  double x,y;
 public: 
  Punkt(double x_, double y_):x(x_),y(y_){}
};

const char* Msg="Hallo Welt"; // ein nullterminierter String

#include <string.h> // eine C-Bibliothek

void f(TextBox^ tb, int n) // eine Funktion
{ // inhaltlich vlliger Unsinn
int a[Max]; // ein Array
for (int i=0; i<Max; i++) // eine Kontrollstruktur
  a[i]=i*i;
int* p=new int; // ein Zeiger
*p=n*strlen(Msg);
for (int i=0; i<Max; i++)
  if (i%10==0)  
    tb->AppendText(String::Format("a[{0}]={1}\r\n",i,a[i]));
}

#include <string>
using std::string; // oder: using namespace std;

string s1="Hallo Welt";

string appendTxtExtension(string fn)
{
if (fn.find(".txt")!=fn.length()-4)
  return fn+".txt";
else return fn;
}

#include <vector>
using std::vector; // oder: using namespace std;

void useVector(TextBox^ textBox1, int n)
{
vector<int> v;
for (int i=1; i<=n; i++) // fgt v 100 Elemente hinzu
  v.push_back(i*i); 
for (int i=0; i<v.size();i++)//oder size_t anstatt int
 textBox1->AppendText(v[i].ToString()+"\r\n");
}

#include <fstream>
using namespace std;

void useFstream(TextBox^ textBox1, int n)
{
ofstream fout("c:\\test.dat",ios::binary);
for (int i=0; i<n; i++)
  fout.write((char*)&i,sizeof(int));
fout.close();
ifstream fin("c:\\test.dat",ios::binary);
int i;
while (fin.read((char*)&i, sizeof(int)))
  textBox1->AppendText(i.ToString()+"\r\n");
fin.close();
}

/* Voraussetzung:
   Unter Projekt|Eigenschaften|Konfigurationseigenschaften|
         C/C++|Allgemein das Verzeichnis mit der Boost-Bibliothek
		 aufnehmen.
#include <boost/crc.hpp>      // for boost::crc_basic, boost::crc_optimal
#include <boost/cstdint.hpp>  // for boost::uint16_t

void testCRC()
{
const char* buf="Hello World";
boost::crc_basic<16>  crc_ccitt1( 0x1021, 0xFFFF, 0, false, false );
crc_ccitt1.process_bytes( buf, strlen(buf) );
int x= crc_ccitt1.checksum() ;
}
*/

#include <memory>
using namespace std::tr1;

void testSharedPtr()
{
shared_ptr<int> s1;              // wie int* p1;
shared_ptr<int> s2(new int(17)); // wie int* p2=new int(18);
} // gibt den Speicher auf das mit new erzeugte Objekt wieder frei

void typischeCppAnweisungen(TextBox^ tb)
{
f(tb, 5); 
useVector(tb, 5);
useFstream(tb, 5);
testSharedPtr();
}


// ####################################################
// Beispiele aus
// Konversionen zwischen string und String 

void testMarshal(TextBox^  tb)
{
#if NOCH_NICHT_IN_VS2010_BETA2 
using msclr::interop::marshal_as; 

std::string s1 = "std::string";
// String^ S1 = marshal_as<String^>(s1);
String^ S2 = "System::String";
// std::string s = marshal_as<std::string>(S2);
tb->AppendText(S1);
// #include <msclr\marshal_cppstd.h>
#endif
}

System::String^ toString(std::string s)
{
return gcnew System::String(s.c_str());
}

std::string tostring(System::String^ S)
{
std::string s;
for (int i=0;i<S->Length; i++)
  s+=S[i];
return s;
}

void testSimpleConvert(TextBox^ tb)
{
std::string s1 = "std::string";
String^ S1 = toString(s1);
String^ S2 = "System::String";
String^ s = toString(s1);
tb->AppendText(S1);
}

void testStringConvert(TextBox^ tb)
{
testMarshal(tb);
testSimpleConvert(tb);
}


// ####################################################
// Beispiele aus
// Einschrnkungen bei der Kombination von nativen und verwalteten Klassen
 
class C2DPunkt{ 
  double x,y;

  void Init(double x_, double y_)
  {
  x = x_;
  y = y_;
  }

  String^ toStr()
  {
  return String::Format("({0}|{1})", x,y);
  } // z.B. (2,345|3,45678) 

  void anzeigen(TextBox^ tb){}
};


// ####################################################
// Beispiele aus
// C++/CLI-Erweiterungen

namespace CppCliErweiterungen {
// namespace nur zur Vermeidung von Namenskonflikten

ref class Punkt{ // eine Verweisklasse
  int x,y;
 public:
  Punkt(int x_, int y_):x(x_),y(y_) {}

  virtual String^ ToString() override 
  { 
  return String::Format("Punkt({0},{1})",x,y); 
  }

};

class Punkt_n { // eine native Klasse
  int x,y;
 public: 
  Punkt_n(int x_, int y_):x(x_),y(y_){}
};

} // end of namespace CppCliErweiterungen 

TextBox^ makeTextBox(Form^ f, int x, int y, int w, int h)
{
TextBox^ t = gcnew TextBox();
t->Location = System::Drawing::Point(x, y);
t->Size = System::Drawing::Size(w, h);
t->Multiline = true;
t->Name = L"makeTextBox1";
f->Controls->Add(t);
return t;
};


typedef int T;
ref class C {
  T fx;
 public: 

  property T x {
    T get()
    {
    return fx;
    }

    void set(T x_)
    {
    fx=x_*x_;
    };
  };
};

void testCppCliErweiterungen(Form^ form, TextBox^ tb)
{
CppCliErweiterungen::Punkt^ p=gcnew CppCliErweiterungen::Punkt(17,18);

TextBox^ t=makeTextBox(form,10,30,90,20);
t->AppendText("bla bla bla");

C^ c=gcnew C;
c->x=2;
int y=c->x; // y==4
tb->AppendText(y.ToString()+"\r\n");
}


// ####################################################
// Beispiele aus
// .NET-Klassen in C++ Windows Forms-Anwendungen
 
using namespace System::Drawing;

void zeichneDiagonale(Graphics^ g)
{ 
Pen^ pen=gcnew Pen(Color::Red, 1);
Point start(0,0);
Point end(g->ClipBounds.Width, g->ClipBounds.Height);
g->DrawLine(pen, start,end);
delete pen; // nicht notwendig
}

void testList(TextBox^ textBox1)
{
using namespace System::Collections::Generic;
List<String^>^ gl = gcnew List<String^>;
gl->Add("one ");
gl->Add("two ");
gl->Add("three ");
for each(String^ i in gl)
  textBox1->AppendText(i);
for (int i=0; i<gl->Count; i++)
  textBox1->AppendText(gl[i]);
}

void f1(TextBox^ tb, String^ path)
{
using namespace System::IO;
StreamReader^ r = gcnew StreamReader(path);
while (!r->EndOfStream)
 {
  tb->AppendText(r->ReadLine()+"\r\n");
 }
r->Close();
}

// ####################################################
// Beispiele aus
// Win32-DLLs und Win32-API Funktionen in Windows Forms-Anwendungen 
  
using namespace System::Runtime::InteropServices;

[DllImport("user32", CharSet=CharSet::Auto)]
int MessageBox(IntPtr hWnd, String^ pText, 
  String ^ pCaption, unsigned int uType);

void call_Win32Messagebox() 
{
String^ pText = "Hello World! ";
String^ pCaption = "Win32 MessageBox";
::MessageBox(IntPtr(0), pText, pCaption, 0);
}




